#include <stdio.h>
#include "genpat.h"

/* Remarques pralables :

   1) Ce fichier sert  gnrer le fichier de patterns 'test.pat'
   (Obligatoire pour le bon fonctionnement du Makefile). Le fichier de
   patterns sera un fichier qui sera utilisable pour le simulation de
   la description VHDL initiale.

   2 ) Ainsi qu'on peut le voir dans ce fichier, on n'affecte pas les
   signaux en sortie. Dans la structure actuelle du Makefile,
   l'utilisateur demande d'abord  voir l'allure de la sortie  partir
   de la description VHDL intiale, et, si celle-ci lui convient, il
   lance la procdure de gnration complte. Une autre solution qui
   aurait t envisageable serait de calculer dans ce fichier la
   sortie  laquelle on doit s'attendre, et d'affecter rellement ce
   rsultat  la sortie(avec AFFECT). Le simulateur prendrait ensuite
   le relai et regarderait si la sortie simule dans la description
   VHDL initiale est bien celle prvue.

*/



/* un CYCLE est une priode pendant laquelle "e" passe  0 puis  1 */
#define NBCYCLES 100


/* la fonction qui suit renvoie un entier sous la forme d'une chane */
char *inttostr(int entier)
{
	char *str=NULL;

	str = (char *) mbkalloc (32 * sizeof (char));
	sprintf (str, "%d",entier);
	return(str);
}
/* remarque : mbkfree et mbkalloc ne sont pour l'instant que de
   simples appels  free et malloc */

main()
{
	/* Les descriptions des fonctions utilises dans ce fichier sont
	   accessibles par les pages de manuels (exemple : man DECLAR) */

	int i;
	int j;
	int cur_vect;

	DEF_GENPAT("test");

	/* interface */
	DECLAR("a", ":2", "X", IN, "3 downto 0");
	DECLAR("b", ":2", "X", IN, "3 downto 0");
	
	DECLAR("sel", ":2", "B", IN, "");
	DECLAR("clk", ":2", "B", IN, "");
	
	DECLAR("s", ":2", "X", OUT, "3 downto 0");


	/* dboguage des lignes internes : changer aussi le fichier
	   diviseur.vbe si on veut visualiser ces lignes */

	AFFECT("0", "a", "0");
	AFFECT("0", "b", "1");
	AFFECT("0", "clk", "0");

	/* on passe un premier cycle avec toute les donnes  0 car asimut
	   ragit diffremment avec les registres au dbut de la
	   simulation selon qu'il simule le fichier VHDL ou la netliste
	   logique produite par scmap */
	AFFECT("0", "sel", "0"); /* slection : incrmentation avec le buffer */
	
    /***********/
	AFFECT("1", "clk", "1");
	AFFECT("2", "sel", "1");
	cur_vect=2;
	for (i=0 ; i<NBCYCLES ; i++)
	{
		AFFECT(inttostr(cur_vect), "clk", "0b0");
		cur_vect++;

		AFFECT(inttostr(cur_vect), "clk", "0b1");
		cur_vect++;

	}

	SAV_GENPAT();
	return 0;
}

