//**********************************************
// File     : sstack_genpat.c
// Author   : Andres Farfan / Modfed by Rafael Becerra
// Date     : 08/01/2000    / Mayo 10 / 2000
//**********************************************

#include <stdio.h>
#include <genpat.h>

char *int2str(unsigned long entero)
{
	char *str;
	str = (char*) mbkalloc (32*sizeof(char));
	sprintf( str, "%lu", entero);
	return(str);
}

int main(void)
{
	int i, j, dato;
	
	// Output file name
	DEF_GENPAT("sstack_genpat");
	SETTUNIT("ns");

	// Input/Output declaration
	DECLAR("STACK_EN", ":2", "X", IN, "7 DOWNTO 0", "");
	DECLAR("STACK_EN_DATA", ":2", "X", IN, "7 DOWNTO 0", "");
	DECLAR("CLK", ":2", "B", IN, "","");	
	
	DECLAR("D",":2", "X", IN, "15 DOWNTO 0","");
	DECLAR("Q", ":2", "X", OUT, "15 DOWNTO 0","");

	DECLAR("vdd", ":2", "B", IN, "","");
	DECLAR("vss", ":2", "B", IN, "","");

	//Patterns
	AFFECT(int2str(0), "vdd", "0b1");
	AFFECT(int2str(0), "vss", "0b0");

	//RELOJ
	for(i = 0, j = 1, dato = 200; i < 400; i=i+40, j++, dato++)
	{
	    AFFECT(int2str(i), "CLK", int2str( j%2 ) );
	    if( (i%20) == 0)
		AFFECT(int2str(i), "D", int2str(dato));
	}

    AFFECT(int2str(0),"D", int2str( 0 ) );
    AFFECT(int2str(0),"STACK_EN", int2str( 1 ) );
    AFFECT(int2str(0),"STACK_EN_DATA", int2str( 1 ) );

    AFFECT(int2str(40),"STACK_EN", int2str( 2 ) );
    AFFECT(int2str(40),"STACK_EN_DATA", int2str( 2 ) );
/*
    AFFECT(int2str(180),"STACK_EN", int2str( 1 ) );
    AFFECT(int2str(180),"STACK_EN_DATA", int2str( 1 ) );

    AFFECT(int2str(320),"STACK_EN", int2str( 8 ) );
    AFFECT(int2str(320),"STACK_EN_DATA", int2str( 8 ) );

    AFFECT(int2str(400),"STACK_EN", int2str( 4 ) );
    AFFECT(int2str(400),"STACK_EN_DATA", int2str( 4 ) );

    AFFECT(int2str(520),"STACK_EN", int2str( 2 ) );
    AFFECT(int2str(520),"STACK_EN_DATA", int2str( 2 ) );

    AFFECT(int2str(600),"STACK_EN", int2str( 4 ) );
    AFFECT(int2str(600),"STACK_EN_DATA", int2str( 4 ) );

*/
	// Save generated file
	SAV_GENPAT();
	
	exit(0);
}
