# -*- Mode: Shell-script -*-
#             ,,,
#            (o o)
####=====oOO--(_)--OOO=========================================####
#
#  Alliance CAD system environnement
#  Usage (in C-shell) : > source alc_env.csh
#  (C) 1997 Czo  -- <Olivier.Sirol@lip6.fr>
#  $Id: alc_env.csh.in,v 1.2 1997/12/15 10:52:02 czo Exp $
#  Generated from alc_env.csh.in on Thu Feb  4 17:26:13 CST 1999

# $MACHINE and $TOP are the only variables you will
# have to modify if something goes wrong

# Which platform for Alliance CAD

switch (`uname`)
	case Linux:
		if ( `uname -r` =~ 1.* ) then
		    setenv MACHINE Linux_aout
		else
		    setenv MACHINE Linux_elf
		endif
	breaksw

	case SunOS:
		if ( `uname -r` =~ 5* ) then
		    setenv MACHINE Solaris
		else
		    setenv MACHINE SunOS
		endif
	breaksw

	default:
		setenv MACHINE Unknown
	breaksw
endsw

# Where the Alliance CAD is installed

setenv TOP /alliance/archi/$MACHINE

# User def 

setenv MBK_IN_LO         vst
setenv MBK_OUT_LO        vst
setenv MBK_IN_PH         ap
setenv MBK_OUT_PH        ap

setenv MBK_WORK_LIB      .
setenv MBK_CATAL_NAME    CATAL

setenv MBK_SCALE_X 10

setenv VH_MAXERR 10
setenv VH_BEHSFX vbe
setenv VH_PATSFX pat

setenv MBK_CATA_LIB      .:$TOP/cells/sclib
setenv MBK_TARGET_LIB    $TOP/cells/sclib
setenv MBK_C4_LIB        ./cellsC4 

setenv XPAT_PARAM_NAME   $TOP/etc/xpat.par
setenv XFSM_PARAM_NAME   $TOP/etc/xfsm.par

#---------------------New Define--------------------------
#setenv DREAL_TECHNO_NAME ~/alliance/new2.dre
setenv GRAAL_TECHNO_NAME ~/alliance/new2.gra

setenv RDS_TECHNO_NAME   ~/alliance/new2.rds



setenv RDS_IN gds
setenv RDS_OUT gds

setenv ELP_TECHNO_NAME   $TOP/etc/prol10_7.elp

# Update PATH and MANPATH
if $?PATH then
#	setenv PATH $HOME/labo/$MACHINE/bin:$TOP/bin:$PATH
	setenv PATH $TOP/bin:$PATH
else
#	setenv PATH $HOME/labo/$MACHINE/bin:$TOP/bin
	setenv PATH $TOP/bin
endif


if $?MANPATH then
	setenv MANPATH $TOP/man:$MANPATH
else
	setenv MANPATH $TOP/man
endif


# Show results
if ($?prompt) then
#	alias xmbk 'eval `\xmbk -c`'
#	cat /users/soft5/newlabo/motd
        echo ""
        echo "Alliance settings :"
        echo ""
        echo "    MACHINE = $MACHINE"
        echo "    TOP     = $TOP"
        echo ""
endif


# EOF 


